#INCLUDE "MATR110.CH"
#INCLUDE "PROTHEUS.CH"
#INCLUDE "TOTVS.CH"
/*
+----------------------------------------------------------------------------+
!                         FICHA TECNICA DO PROGRAMA                          !
+----------------------------------------------------------------------------+
!   DADOS DO PROGRAMA                                                        !
+------------------+---------------------------------------------------------+
!Tipo              ! Relatrio                                               !
+------------------+---------------------------------------------------------+
!Modulo            ! COM - Compras                                           !
+------------------+---------------------------------------------------------+
!Nome              ! RCOM001                                                 !
+------------------+---------------------------------------------------------+
!Descricao         ! Impresso do Pedido de Compras                          !
+------------------+---------------------------------------------------------+
!Autor             ! RODRIGO L P ARAUJO                            			 !
+------------------+---------------------------------------------------------+
!Data de Criacao   ! 12/02/2012                                              !
+------------------+---------------------------------------------------------+
*/

User Function RCOM001( cAlias, nRecno, nOpc )
	Local aArea    := GetArea()
	Local cPrinter := SuperGetMv("MV_PCOMPRA" ,, "" )
	Local lBackPed := lPedido
	Local lRet     := .T.

	Private cPedido  := ""
	Private cPerg := "RCOM001"

	cPedido := SC7->C7_NUM

	lRet := U_RCOM001I( cAlias, nRecno, nOpc )

	RestArea( aArea )
	lPedido := lBackPed

	If Type( "bFiltraBRW" ) == "B"
		Eval( bFiltraBRW )
	EndIf

Return( lRet )

User Function RCOM001I( cAlias, nReg, nOpcx )
	Local oReport
	Private lAuto := (nReg!=Nil)

	oReport:= ReportDef(nReg, nOpcx)
	oReport:PrintDialog()

Return

/*/


Ŀ
Programa   ReportDefAutor  Alexandre Inacio Lemes Data  06/09/2006
Ĵ
Descrio  Pedido de Compras / Autorizacao de Entrega                 
Ĵ
Parametros nExp01: nReg = Registro posicionado do SC7 apartir Browse  
           nExp02: nOpcx= 1 - PC / 2 - AE                             
Ĵ
Retorno    oExpO1: Objeto do relatorio                                
ٱ


/*/
Static Function ReportDef(nReg,nOpcx)
	Local cTitle   := STR0003 // "Emissao dos Pedidos de Compras ou Autorizacoes de Entrega"
	Local oReport
	Local oSection1
	Local oSection2
	Local nTamCdProd:= TamSX3("C7_PRODUTO")[1]
	Local nTamCdDesc:= TamSX3("B1_DESC")[1]

	//Ŀ
	// Variaveis utilizadas para parametros                         
	// mv_par01               Do Pedido                             
	// mv_par02               Ate o Pedido                          
	// mv_par03               A partir da data de emissao           
	// mv_par04               Ate a data de emissao                 
	// mv_par05               Somente os Novos                      
	// mv_par06               Campo Descricao do Produto    	     
	// mv_par07               Unidade de Medida:Primaria ou Secund. 
	// mv_par08               Imprime ? Pedido Compra ou Aut. Entreg
	// mv_par09               Numero de vias                        
	// mv_par10               Pedidos ? Liberados Bloqueados Ambos  
	// mv_par11               Impr. SC's Firmes, Previstas ou Ambas 
	// mv_par12               Qual a Moeda ?                        
	// mv_par13               Endereco de Entrega                   
	// mv_par14               todas ou em aberto ou atendidos       
	//

	AjustaSX1()
	Pergunte(cPerg,.F.)

	dbSelectArea("SX1")
	dbSetOrder(1)
	dbSeek(cPerg)
	While !Eof() .And. AllTrim(SX1->X1_GRUPO) == cPerg
		If SX1->X1_ORDEM $ "01/02"
			RecLock("SX1",.F.)
			SX1->X1_CNT01 := SC7->C7_NUM
			MsUnlock()
		EndIf
		dbSelectArea("SX1")
		dbSkip()
	EndDo

	Pergunte(cPerg,.F.)

	MV_PAR02 := MV_PAR01 := SC7->C7_NUM

	//Ŀ
	//Criacao do componente de impressao                                      
	//                                                                        
	//TReport():New                                                           
	//ExpC1 : Nome do relatorio                                               
	//ExpC2 : Titulo                                                          
	//ExpC3 : Pergunte                                                        
	//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
	//ExpC5 : Descricao                                                       
	//
	oReport:= TReport():New(cPerg,cTitle,cPerg, {|oReport| ReportPrint(oReport,nReg,nOpcx)},STR0001+" "+STR0002)
	oReport:SetPortrait()
	oReport:HideParamPage()
	oReport:HideHeader()
	oReport:HideFooter()
	oReport:SetTotalInLine(.F.)

	//Ŀ
	//Criacao da secao utilizada pelo relatorio                               
	//                                                                        
	//TRSection():New                                                         
	//ExpO1 : Objeto TReport que a secao pertence                             
	//ExpC2 : Descricao da seao                                              
	//ExpA3 : Array com as tabelas utilizadas pela secao. A primeira tabela   
	//        sera considerada como principal para a seo.                   
	//ExpA4 : Array com as Ordens do relatrio                                
	//ExpL5 : Carrega campos do SX3 como celulas                              
	//        Default : False                                                 
	//ExpL6 : Carrega ordens do Sindex                                        
	//        Default : False                                                 
	//
	//Ŀ
	//Criacao da celulas da secao do relatorio                                
	//                                                                        
	//TRCell():New                                                            
	//ExpO1 : Objeto TSection que a secao pertence                            
	//ExpC2 : Nome da celula do relatrio. O SX3 ser consultado              
	//ExpC3 : Nome da tabela de referencia da celula                          
	//ExpC4 : Titulo da celula                                                
	//        Default : X3Titulo()                                            
	//ExpC5 : Picture                                                         
	//        Default : X3_PICTURE                                            
	//ExpC6 : Tamanho                                                         
	//        Default : X3_TAMANHO                                            
	//ExpL7 : Informe se o tamanho esta em pixel                              
	//        Default : False                                                 
	//ExpB8 : Bloco de cdigo para impressao.                                 
	//        Default : ExpC2                                                 
	//
	oSection1:= TRSection():New(oReport,"Pedido de Compras",{"SC7","SM0","SA2"},/*aOrdem*/) //"| P E D I D O  D E  C O M P R A S"
	oSection1:SetLineStyle()
	oSection1:SetReadOnly()

	TRCell():New(oSection1,"M0_NOMECOM","SM0","Empresa"      ,/*Picture*/,49,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"A2_COD"    ,"SA2",/*Titulo*/   ,/*Picture*/,20,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"A2_LOJA"   ,"SA2",/*Titulo*/   ,/*Picture*/,04,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"A2_NOME"   ,"SA2",/*Titulo*/   ,/*Picture*/,40,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"M0_ENDENT" ,"SM0","Endereo"      ,/*Picture*/,48,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"A2_END"    ,"SA2",/*Titulo*/   ,/*Picture*/,40,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"A2_BAIRRO" ,"SA2",/*Titulo*/   ,/*Picture*/,25,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"M0_CEPENT" ,"SM0","CEP"        ,/*Picture*/,11,/*lPixel*/,{|| Trans(SM0->M0_CEPENT,PesqPict("SA2","A2_CEP")) })
	TRCell():New(oSection1,"M0_CIDENT" ,"SM0","Cidade"      ,/*Picture*/,30,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"M0_ESTENT" ,"SM0","UF"         ,/*Picture*/,03,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"A2_MUN"    ,"SA2",/*Titulo*/   ,/*Picture*/,30,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"A2_EST"    ,"SA2",/*Titulo*/   ,/*Picture*/,02,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"A2_CEP"    ,"SA2",/*Titulo*/   ,/*Picture*/,08,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"A2_CGC"    ,"SA2",/*Titulo*/   ,/*Picture*/,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"M0_TEL"    ,"SM0","Tel"      ,/*Picture*/,15,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"M0_FAX"    ,"SM0","Fax"      ,/*Picture*/,34,/*lPixel*/,/*{|| code-block de impressao }*/)
	TRCell():New(oSection1,"FONE"      ,"   ","Tel"      ,/*Picture*/,25,/*lPixel*/,{|| "("+Substr(SA2->A2_DDD,1,3)+") "+Substr(SA2->A2_TEL,1,15)})
	TRCell():New(oSection1,"FAX"       ,"   ","Fax"      ,/*Picture*/,25,/*lPixel*/,{|| "("+Substr(SA2->A2_DDD,1,3)+") "+SubStr(SA2->A2_FAX,1,15)})
	TRCell():New(oSection1,"INSCR"     ,"   ",If( cPaisLoc$"ARG|POR|EUA",space(11) , "IE" ),/*Picture*/,20,/*lPixel*/,{|| If( cPaisLoc$"ARG|POR|EUA",space(18), SA2->A2_INSCR ) })
	TRCell():New(oSection1,"M0_CGC"    ,"SM0","CNPJ"      ,/*Picture*/,18,/*lPixel*/,{|| Transform(SM0->M0_CGC,PesqPict("SA2","A2_CGC")) })

	If cPaisLoc == "BRA"
		TRCell():New(oSection1,"M0IE"  ,"   ","IE"      ,/*Picture*/,20,/*lPixel*/,{|| InscrEst()})
	EndIf

	oSection1:Cell("A2_BAIRRO"):SetCellBreak()
	oSection1:Cell("A2_CGC"   ):SetCellBreak()
	oSection1:Cell("INSCR"    ):SetCellBreak()

	oSection2:= TRSection():New(oSection1,"Ordem",{"SC7","SB1"},/*aOrdem*/)
	oSection2:SetCellBorder("ALL",,,.T.)
	oSection2:SetCellBorder("RIGHT")
	oSection2:SetCellBorder("LEFT")

	TRCell():New(oSection2,"C7_ITEM"    ,"SC7"	,/*Titulo*/	,/*Picture*/,04,/*lPixel*/,/*{|| code-block de impressao }*/,,,,,,.F.)
	TRCell():New(oSection2,"C7_PRODUTO" ,"SC7"	,/*Titulo*/	,/*Picture*/,15,/*lPixel*/,/*{|| code-block de impressao }*/,,,,,,.F.)
	TRCell():New(oSection2,"DESCPROD"   ,"   "	,"Descrio",/*Picture*/,35,/*lPixel*/, {|| cDescPro},,,,,,.F.)
	TRCell():New(oSection2,"C7_UM"      ,"SC7"	,"UM"   	,/*Picture*/,02,/*lPixel*/,/*{|| code-block de impressao }*/,,,,,,.F.)
	TRCell():New(oSection2,"C7_SEGUM"   ,"SC7"	,"SUM"   	,/*Picture*/,10,/*lPixel*/,/*{|| code-block de impressao }*/,,,,,,.F.)
	TRCell():New(oSection2,"C7_QUANT"   ,"SC7"	,/*Titulo*/	,PesqPictQt("C7_QUANT",13),13,/*lPixel*/,/*{|| code-block de impressao }*/,,,,,,.F.)
	TRCell():New(oSection2,"C7_QTSEGUM" ,"SC7"	,/*Titulo*/	,PesqPictQt("C7_QUANT",13),15,/*lPixel*/,/*{|| code-block de impressao }*/,,,,,,.F.)
	TRCell():New(oSection2,"PRECO"      ,"   "	,"Preco"	,/*Picture*/,15/*Tamanho*/,/*lPixel*/,{|| nVlUnitSC7 },"RIGHT",,"RIGHT")
	TRCell():New(oSection2,"TOTAL"     	,"   "	,"Total"	,/*Picture*/,15,/*lPixel*/,{|| nValTotSC7 },"RIGHT",,"RIGHT",,,.F.)
	TRCell():New(oSection2,"C7_DATPRF"  ,"SC7"	,/*Titulo*/	,/*Picture*/,10,/*lPixel*/,/*{|| code-block de impressao }*/,,,,,,.F.)
	TRCell():New(oSection2,"C7_ITEMCTA" ,"SC7"	,"It.Conta"	,/*Picture*/,07,/*lPixel*/,/*{|| code-block de impressao }*/,,,,,,.F.)
	TRCell():New(oSection2,"NOITEMCTA" 	," "	,"Nome"		,/*Picture*/,23,/*lPixel*/,{|| cNomeItem },,,,,,.F.)
	TRCell():New(oSection2,"C7_CC"  	,"SC7"	,"C.C"		,/*Picture*/,07,/*lPixel*/,/*{|| code-block de impressao }*/,,,,,,.F.)
	TRCell():New(oSection2,"STATUS"  	,""		,"ST"		,/*Picture*/,02,/*lPixel*/,{|| cStatus },,,,,,.F.)
	//TRCell():New(oSection2,"C7_ZZREMBO"	,"SC7"	,"REEB"		,/*Picture*/,01,/*lPixel*/,{|| cReembolso },,,,,,.F.)

	//ALINHAMENTO
	oSection2:Cell("C7_ITEM"):SetAlign("CENTER")
	oSection2:Cell("C7_PRODUTO"):SetAlign("LEFT")
	oSection2:Cell("C7_UM"):SetAlign("CENTER")
	oSection2:Cell("C7_SEGUM"):SetAlign("CENTER")
	oSection2:Cell("C7_DATPRF"):SetAlign("CENTER")
	oSection2:Cell("C7_ITEMCTA"):SetAlign("CENTER")
	oSection2:Cell("C7_CC"):SetAlign("CENTER")
	oSection2:Cell("STATUS"):SetAlign("CENTER")
	//oSection2:Cell("C7_ZZREMBO"):SetAlign("CENTER")


	oSection2:Cell("C7_PRODUTO"):SetLineBreak()
	oSection2:Cell("DESCPROD"):SetLineBreak()

	//oSection2:Cell("C7_IPI"):SetTitle(STR0119)

	//oSection2:Cell("C7_PRODUTO"):SetSize(50)
	//oSection2:Cell("C7_IPI"):SetSize(10)

Return(oReport)

/*/


Ŀ
Programa  ReportPrin Autor Alexandre Inacio Lemes Data  06/09/2006
Ĵ
Descrio  Emissao do Pedido de Compras / Autorizacao de Entrega      
Ĵ
Sintaxe    ReportPrint(ExpO1,ExpN1,ExpN2)                             
Ĵ
Parametros ExpO1 = Objeto oReport                      	              
           ExpN1 = Numero do Recno posicionado do SC7 impressao Menu  
           ExpN2 = Numero da opcao para impressao via menu do PC      
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosExpO1: Objeto Report do Relatrio                           
ٱ


/*/
Static Function ReportPrint(oReport,nReg,nOpcX)

Local oSection1   := oReport:Section(1)
Local oSection2   := oReport:Section(1):Section(1)

Local aRecnoSave  := {}
Local aPedido     := {}
Local aPedMail    := {}
Local aValIVA     := {}

Local cNumSC7     := Len(SC7->C7_NUM)
Local cCondicao   := ""
Local cFiltro     := ""
Local cComprador  := ""
LOcal cAlter	  := ""
Local cTipoSC7    := ""
Local cCondBus    := ""
Local cMensagem   := ""
Local cVar        := ""
Local cPictVUnit := PesqPict("SC7","C7_PRECO",16)
Local cPictVTot  := PesqPict("SC7","C7_TOTAL",, mv_par12)
Local lNewAlc	  := .F.
Local lLiber      := .F.
Local nW          := 0
Local nRecnoSC7   := 0
Local nRecnoSM0   := 0
Local nX          := 0
Local nY          := 0
Local nVias       := 0
Local nTxMoeda    := 0
Local nPageWidth  := 2290 // oReport:PageWidth()
Local nPrinted    := 0
Local nValIVA     := 0
Local nTotIpi	  := 0
Local nTotIcms	  := 0
Local nTotDesp	  := 0
Local nTotFrete	  := 0
Local nTotalNF	  := 0
Local nTotSeguro  := 0
Local nLinPC	  := 0
Local nLinObs     := 0
Local nDescProd   := 0
Local nTotal      := 0
Local nTotMerc    := 0
Local nPagina     := 0
Local nOrder      := 1
Local cUserId     := RetCodUsr()
Local cCont       := Nil
Local lImpri      := .F.

Private cDescPro  := ""
Private cNomeItem := ""
Private cStatus   := ""
Private cReembolso:= ""
Private cOPCC     := ""
Private	nVlUnitSC7:= 0
Private nValTotSC7:= 0
Private cAprov1   := ""
Private cAprov2   := ""
Private cAprov3   := ""
Private cAprovFim := ""
Private aAprov1   := {}
Private aAprov2   := {}
Private aAprov3   := {}
Private aAprovFim := {}
Private cObs01    := ""
Private cObs02    := ""
Private cObs03    := ""
Private cObs04    := ""
Private cObs05    := ""

If Type("lPedido") != "L"
	lPedido := .F.
Endif

dbSelectArea("SC7")

/*
If lAuto
	dbSelectArea("SC7")
	dbGoto(nReg)
	mv_par01 := SC7->C7_NUM
	mv_par02 := SC7->C7_NUM
	mv_par03 := SC7->C7_EMISSAO
	mv_par04 := SC7->C7_EMISSAO
	mv_par05 := Eval({|| cCont:=ChkPergUs(cUserId,cPerg,"05"),If(cCont == Nil,2,cCont) })
   	mv_par08 := Eval({|| cCont:=ChkPergUs(cUserId,cPerg,"08"),If(cCont == Nil,C7_TIPO,cCont) })
	mv_par09 := Eval({|| cCont:=ChkPergUs(cUserId,cPerg,"09"),If(cCont == Nil,1,cCont) })
  	mv_par10 := Eval({|| cCont:=ChkPergUs(cUserId,cPerg,"10"),If(cCont == Nil,3,cCont) })
	mv_par11 := Eval({|| cCont:=ChkPergUs(cUserId,cPerg,"11"),If(cCont == Nil,3,cCont) })
  	mv_par14 := Eval({|| cCont:=ChkPergUs(cUserId,cPerg,"14"),If(cCont == Nil,1,cCont) })
Else
*/
	MakeAdvplExpr(oReport:uParam)

	cCondicao := 'C7_FILIAL=="'       + xFilial("SC7") + '".And.'
	cCondicao += 'C7_NUM>="'          + mv_par01       + '".And.C7_NUM<="'          + mv_par02 + '".And.'
	cCondicao += 'Dtos(C7_EMISSAO)>="'+ Dtos(mv_par03) +'".And.Dtos(C7_EMISSAO)<="' + Dtos(mv_par04) + '"'

	oReport:Section(1):SetFilter(cCondicao,IndexKey())
//EndIf

If lPedido
	mv_par12 := MAX(SC7->C7_MOEDA,1)
Endif

If SC7->C7_TIPO == 1 .OR. SC7->C7_TIPO == 3
	If ( cPaisLoc$"ARG|POR|EUA" )
		cCondBus := "1"+StrZero(Val(mv_par01),6)
		nOrder	 := 10
	Else
		cCondBus := mv_par01
		nOrder	 := 1
	EndIf
Else
	cCondBus := "2"+StrZero(Val(mv_par01),6)
	nOrder	 := 10
EndIf

If mv_par14 == 2
	cFiltro := "SC7->C7_QUANT-SC7->C7_QUJE <= 0 .Or. !EMPTY(SC7->C7_RESIDUO)"
Elseif mv_par14 == 3
	cFiltro := "SC7->C7_QUANT > SC7->C7_QUJE"
EndIf

oSection2:Cell("PRECO"):SetPicture(cPictVUnit)
oSection2:Cell("TOTAL"):SetPicture(cPictVTot)

TRPosition():New(oSection2,"SB1",1,{ || xFilial("SB1") + SC7->C7_PRODUTO })
TRPosition():New(oSection2,"SB5",1,{ || xFilial("SB5") + SC7->C7_PRODUTO })

//Ŀ
// Executa o CodeBlock com o PrintLine da Sessao 1 toda vez que rodar o oSection1:Init()   
//
oReport:onPageBreak( { || nPagina++ , nPrinted := 0 , CabecPCxAE(oReport,oSection1,nVias,nPagina) })

oReport:SetMeter(SC7->(LastRec()))
dbSelectArea("SC7")
dbSetOrder(nOrder)
dbSeek(xFilial("SC7")+cCondBus,.T.)

oSection2:Init()

cNumSC7 := SC7->C7_NUM

While !oReport:Cancel() .And. !SC7->(Eof()) .And. SC7->C7_FILIAL == xFilial("SC7") .And. SC7->C7_NUM >= mv_par01 .And. SC7->C7_NUM <= mv_par02

	If (SC7->C7_CONAPRO == "B" .And. mv_par10 == 1) .Or.;
		(SC7->C7_CONAPRO <> "B" .And. mv_par10 == 2) .Or.;
		(SC7->C7_EMITIDO == "S" .And. mv_par05 == 1) .Or.;
		((SC7->C7_EMISSAO < mv_par03) .Or. (SC7->C7_EMISSAO > mv_par04)) .Or.;
		((SC7->C7_TIPO == 1 .OR. SC7->C7_TIPO == 3) .And. mv_par08 == 2) .Or.;
		(SC7->C7_TIPO == 2 .And. (mv_par08 == 1 .OR. mv_par08 == 3)) .Or. !MtrAValOP(mv_par11, "SC7") .Or.;
		(SC7->C7_QUANT > SC7->C7_QUJE .And. mv_par14 == 3) .Or.;
		((SC7->C7_QUANT - SC7->C7_QUJE <= 0 .Or. !Empty(SC7->C7_RESIDUO)) .And. mv_par14 == 2 )

		dbSelectArea("SC7")
		dbSkip()
		Loop
	Endif

	If oReport:Cancel()
		Exit
	EndIf

	MaFisEnd()
	R110FiniPC(SC7->C7_NUM,,,cFiltro)

	cObs01    := " "
	cObs02    := " "
	cObs03    := " "
	cObs04    := " "

	//Ŀ
	// Roda a impressao conforme o numero de vias informado no mv_par09 
	//
	For nVias := 1 to mv_par09

		//Ŀ
		// Dispara a cabec especifica do relatorio.                     
		//
		oReport:EndPage()

		nPagina  := 0
		nPrinted := 0
		nTotal   := 0
		nTotMerc := 0
		nDescProd:= 0
		nLinObs  := 0
		nRecnoSC7:= SC7->(Recno())
		cNumSC7  := SC7->C7_NUM
		aPedido  := {SC7->C7_FILIAL,SC7->C7_NUM,SC7->C7_EMISSAO,SC7->C7_FORNECE,SC7->C7_LOJA,SC7->C7_TIPO}
		nQtd := 0
		nQtdL:= 0
		cMensagem := ""
		While !oReport:Cancel() .And. !SC7->(Eof()) .And. SC7->C7_FILIAL == xFilial("SC7") .And. SC7->C7_NUM == cNumSC7
			nQtd++
			If (SC7->C7_CONAPRO == "B" .And. mv_par10 == 1) .Or.;
				(SC7->C7_CONAPRO <> "B" .And. mv_par10 == 2) .Or.;
				(SC7->C7_EMITIDO == "S" .And. mv_par05 == 1) .Or.;
				((SC7->C7_EMISSAO < mv_par03) .Or. (SC7->C7_EMISSAO > mv_par04)) .Or.;
				((SC7->C7_TIPO == 1 .OR. SC7->C7_TIPO == 3) .And. mv_par08 == 2) .Or.;
				(SC7->C7_TIPO == 2 .And. (mv_par08 == 1 .OR. mv_par08 == 3)) .Or. !MtrAValOP(mv_par11, "SC7") .Or.;
				(SC7->C7_QUANT > SC7->C7_QUJE .And. mv_par14 == 3) .Or.;
				((SC7->C7_QUANT - SC7->C7_QUJE <= 0 .Or. !Empty(SC7->C7_RESIDUO)) .And. mv_par14 == 2 )
				dbSelectArea("SC7")
				dbSkip()
				Loop
			Endif

			If oReport:Cancel()
				Exit
			EndIf

			oReport:IncMeter()

			If oReport:Row() > oReport:LineHeight() * 100
				oReport:Box( oReport:Row(),010,oReport:Row() + oReport:LineHeight() * 3, nPageWidth )
				oReport:SkipLine()
				oReport:PrintText(STR0101,, 050 ) // Continua na Proxima pagina ....
				oReport:EndPage()
			EndIf

			//Ŀ
			// Salva os Recnos do SC7 no aRecnoSave para marcar reimpressao.
			//
			If Ascan(aRecnoSave,SC7->(Recno())) == 0
				AADD(aRecnoSave,SC7->(Recno()))
			Endif

			//Ŀ
			// Inicializa o descricao do Produto conf. parametro digitado.
			//
			cDescPro := ""
			cNomeItem:= ""
			cStatus  := "BL"

			if SC7->C7_CONAPRO=="L" .and. (!empty(SC7->C7_XLIBN1) .OR. !empty(SC7->C7_XLIBN2) .OR. !empty(SC7->C7_XLIBN3) )
				cStatus := "OK"
				nQtdL++
			Endif

			//cReembolso := SC7->C7_ZZREMBO


			//ALERT(SC7->C7_ITEM+"APROVADOR 1: "+SC7->C7_XLIBN1)
			AADD(aAprov1   ,SC7->C7_XLIBN1)
			AADD(aAprov2   ,SC7->C7_XLIBN2)
			AADD(aAprov3   ,SC7->C7_XLIBN3)
			//AADD(aAprovFim,SC7->C7_XLIBN2)

			cMensagem += SC7->C7_OBS + chr(13)+chr(10)

			dbSelectArea("CTD")
			CTD->(dbSetOrder(1))
			CTD->(dbGoTop())
			if CTD->(dbSeek(xFilial("CTD")+SC7->C7_ITEMCTA))
				cNomeItem:= Substr(CTD->CTD_DESC01,1,40)
			Endif

			If Empty(mv_par06)
				mv_par06 := "B1_DESC"
			EndIf

			If AllTrim(mv_par06) == "B1_DESC"
				SB1->(dbSetOrder(1))
				SB1->(dbSeek( xFilial("SB1") + SC7->C7_PRODUTO ))
				cDescPro := SB1->B1_DESC
			ElseIf AllTrim(mv_par06) == "B5_CEME"
				SB5->(dbSetOrder(1))
				If SB5->(dbSeek( xFilial("SB5") + SC7->C7_PRODUTO ))
					cDescPro := SB5->B5_CEME
				EndIf
			ElseIf AllTrim(mv_par06) == "C7_DESCRI"
				cDescPro := SC7->C7_DESCRI
			EndIf

			If Empty(cDescPro)
				SB1->(dbSetOrder(1))
				SB1->(dbSeek( xFilial("SB1") + SC7->C7_PRODUTO ))
				cDescPro := SB1->B1_DESC
			EndIf

			SA5->(dbSetOrder(1))
			If SA5->(dbSeek(xFilial("SA5")+SC7->C7_FORNECE+SC7->C7_LOJA+SC7->C7_PRODUTO)) .And. !Empty(SA5->A5_CODPRF)
				cDescPro := cDescPro + " ("+Alltrim(SA5->A5_CODPRF)+")"
			EndIf



			If SC7->C7_DESC1 != 0 .Or. SC7->C7_DESC2 != 0 .Or. SC7->C7_DESC3 != 0
				nDescProd+= CalcDesc(SC7->C7_TOTAL,SC7->C7_DESC1,SC7->C7_DESC2,SC7->C7_DESC3)
			Else
				nDescProd+=SC7->C7_VLDESC
			Endif
			//Ŀ
			// Inicializacao da Observacao do Pedido.                       
			//
			If !Empty(SC7->C7_OBS) .And. nLinObs < 5
				nLinObs++
				cVar:="cObs"+StrZero(nLinObs,2)
				Eval(MemVarBlock(cVar),SC7->C7_OBS)
			Endif

			nTxMoeda   := IIF(SC7->C7_TXMOEDA > 0,SC7->C7_TXMOEDA,Nil)
			nValTotSC7 := xMoeda(SC7->C7_TOTAL,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda)

			nTotal     := nTotal + SC7->C7_TOTAL
			nTotMerc   := MaFisRet(,"NF_TOTAL")

			If MV_PAR07 == 2 .And. !Empty(SC7->C7_QTSEGUM) .And. !Empty(SC7->C7_SEGUM)
				oSection2:Cell("C7_DATPRF"):SetSize(9)
				oSection2:Cell("C7_SEGUM"  ):Enable()
				oSection2:Cell("C7_QTSEGUM"):Enable()
				oSection2:Cell("C7_UM"     ):Disable()
				oSection2:Cell("C7_QUANT"  ):Disable()
				nVlUnitSC7 := xMoeda((SC7->C7_TOTAL/SC7->C7_QTSEGUM),SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda)
			Else
				oSection2:Cell("C7_DATPRF"):SetSize(11)
				oSection2:Cell("C7_SEGUM"  ):Disable()
				oSection2:Cell("C7_QTSEGUM"):Disable()
				oSection2:Cell("C7_UM"     ):Enable()
				oSection2:Cell("C7_QUANT"  ):Enable()
				nVlUnitSC7 := xMoeda(SC7->C7_PRECO,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda)
			EndIf

			If cPaisLoc <> "BRA" .Or. mv_par08 == 2
				oSection2:Cell("C7_IPI" ):Disable()
			EndIf

			oSection2:PrintLine()

			nPrinted ++
			lImpri  := .T.
			dbSelectArea("SC7")
			dbSkip()

		EndDo

		SC7->(dbGoto(nRecnoSC7))

		If oReport:Row() > oReport:LineHeight() * 68

			oReport:Box( oReport:Row(),010,oReport:Row() + oReport:LineHeight() * 3, nPageWidth )
			oReport:SkipLine()
			oReport:PrintText(STR0101,, 050 ) // Continua na Proxima pagina ....

			//Ŀ
			// Dispara a cabec especifica do relatorio.                     
			//
			oReport:EndPage()
			oReport:PrintText(" ",1992 , 010 ) // Necessario para posicionar Row() para a impressao do Rodape

			oReport:Box( 280,010,oReport:Row() + oReport:LineHeight() * ( 93 - nPrinted ) , nPageWidth )

		Else
			oReport:Box( oReport:Row(),oReport:Col(),oReport:Row() + oReport:LineHeight() * ( 93 - nPrinted ) , nPageWidth )
		EndIf

		oReport:Box( 1990 ,010,oReport:Row() + oReport:LineHeight() * ( 93 - nPrinted ) , nPageWidth )
		oReport:Box( 2080 ,010,oReport:Row() + oReport:LineHeight() * ( 93 - nPrinted ) , nPageWidth )
		oReport:Box( 2200 ,010,oReport:Row() + oReport:LineHeight() * ( 93 - nPrinted ) , nPageWidth )
		oReport:Box( 2320 ,010,oReport:Row() + oReport:LineHeight() * ( 93 - nPrinted ) , nPageWidth )

		oReport:Box( 2200 , 1080 , 2320 , 1400 ) // Box da Data de Emissao
		oReport:Box( 2320 ,  010 , 2430 , 1220 ) // Box do Reajuste
		oReport:Box( 2320 , 1220 , 2460 , 1750 ) // Box do IPI e do Frete
		oReport:Box( 2320 , 1750 , 2460 , nPageWidth ) // Box do ICMS Despesas e Seguro
		oReport:Box( 2430 ,  010 , 2800 , 1220 ) // Box das Observacoes

		//cMensagem:= Formula(C7_MSG)
		//If !Empty(cMensagem)
		//	oReport:SkipLine()
		//	oReport:PrintText(PadR(cMensagem,129), , oSection2:Cell("DESCPROD"):ColPos() )
		//Endif

		oReport:Say(1900,0050,"Produto deve atender a requisitos da norma diretiva ROHS.")
		oReport:Say(1935,0050,"Obrigatoriamente envio de Arquivo XML ref. NF-e para nfe.cwb@marel.com")

		oReport:PrintText( STR0007 /*"D E S C O N T O S -->"*/ + " " + ;
		TransForm(SC7->C7_DESC1,"999.99" ) + " %    " + ;
		TransForm(SC7->C7_DESC2,"999.99" ) + " %    " + ;
		TransForm(SC7->C7_DESC3,"999.99" ) + " %    " + ;
		TransForm(xMoeda(nDescProd,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , PesqPict("SC7","C7_VLDESC",14, MV_PAR12) ),;
		2022 , 050 )

		oReport:SkipLine()
		oReport:SkipLine()
		oReport:SkipLine()

		//Ŀ
		// Posiciona o Arquivo de Empresa SM0.                          
		// Imprime endereco de entrega do SM0 somente se o MV_PAR13 =" "
		// e o Local de Cobranca :                                      
		//
		SM0->(dbSetOrder(1))
		nRecnoSM0 := SM0->(Recno())
		SM0->(dbSeek(SUBS(cNumEmp,1,2)+SC7->C7_FILENT))

		//If Empty(SC7->C7_ENDENT) //"Local de Entrega  : "
		//	oReport:PrintText(STR0008 + SM0->M0_ENDENT+"  "+SM0->M0_CIDENT+"  - "+SM0->M0_ESTENT+" - "+STR0009+" "+Trans(Alltrim(SM0->M0_CEPENT),PesqPict("SA2","A2_CEP")),, 050 )
		//Else
			oReport:PrintText(STR0008 + mv_par13,, 050 ) //"Local de Entrega  : " imprime o endereco digitado na pergunte
		//Endif
		SM0->(dbGoto(nRecnoSM0))
		oReport:PrintText(STR0010 + Alltrim(SM0->M0_ENDCOB)+"  "+Alltrim(SM0->M0_CIDCOB)+"  - "+Alltrim(SM0->M0_ESTCOB)+" - "+STR0009+" "+Trans(Alltrim(SM0->M0_CEPCOB),PesqPict("SA2","A2_CEP")),, 050 )

		oReport:SkipLine()
		oReport:SkipLine()

		SE4->(dbSetOrder(1))
		SE4->(dbSeek(xFilial("SE4")+SC7->C7_COND))

		nLinPC := oReport:Row()
		oReport:PrintText( STR0011+SubStr(SE4->E4_COND,1,40),nLinPC,050 )
		oReport:PrintText( STR0070,nLinPC,1120 ) //"Data de Emissao"
		oReport:PrintText( STR0013 +" "+ Transform(xMoeda(nTotal,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nTotal,14,MsDecimais(MV_PAR12)) ),nLinPC,1612 ) //"Total das Mercadorias : "
		oReport:SkipLine()
		nLinPC := oReport:Row()

		If cPaisLoc<>"BRA"
			aValIVA := MaFisRet(,"NF_VALIMP")
			nValIVA :=0
			If !Empty(aValIVA)
				For nY:=1 to Len(aValIVA)
					nValIVA+=aValIVA[nY]
				Next nY
			EndIf
			oReport:PrintText(SubStr(SE4->E4_DESCRI,1,34),nLinPC, 050 )
			oReport:PrintText( dtoc(SC7->C7_EMISSAO),nLinPC,1120 )
			oReport:PrintText( STR0063+ "   " + ; //"Total dos Impostos:    "
			Transform(xMoeda(nValIVA,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nValIVA,14,MsDecimais(MV_PAR12)) ),nLinPC,1612 )
		Else
			oReport:PrintText( SubStr(SE4->E4_DESCRI,1,34),nLinPC, 050 )
			oReport:PrintText( dtoc(SC7->C7_EMISSAO),nLinPC,1120 )
			oReport:PrintText( STR0064+ "  " + ; //"Total com Impostos:    "
			Transform(xMoeda(nTotMerc,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nTotMerc,14,MsDecimais(MV_PAR12)) ),nLinPC,1612 )
		Endif
		oReport:SkipLine()

		nTotIpi	  := MaFisRet(,'NF_VALIPI')
		nTotIcms  := MaFisRet(,'NF_VALICM')
		nTotDesp  := MaFisRet(,'NF_DESPESA')
		nTotFrete := MaFisRet(,'NF_FRETE')
		nTotSeguro:= MaFisRet(,'NF_SEGURO')
		nTotalNF  := MaFisRet(,'NF_TOTAL')

		oReport:SkipLine()

		oReport:PrintText("Preo fixo no sujeito a reajuste.",,50)
		nLinPC := oReport:Row()
		oReport:PrintText("Recebimento: segunda  sexta-feira das 08:00 s 12:00 e das 13:00 s 17:00 horas.",,50)
		oReport:PrintText("A data de entrega acima especificada est acondicionada a chegada a Empresa.",,50)

//		oReport:SkipLine()

		SM4->(dbSetOrder(1))
		If SM4->(dbSeek(xFilial("SM4")+SC7->C7_REAJUST))
			oReport:PrintText(  STR0014 + " " + SC7->C7_REAJUST + " " + SM4->M4_DESCR ,nLinPC, 050 )  //"Reajuste :"
		EndIf

		If cPaisLoc == "BRA"
			oReport:PrintText( STR0071 + Transform(xMoeda(nTotIPI ,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nTotIpi ,14,MsDecimais(MV_PAR12))) ,nLinPC,1320 ) //"IPI      :"
			oReport:PrintText( STR0072 + Transform(xMoeda(nTotIcms,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nTotIcms,14,MsDecimais(MV_PAR12))) ,nLinPC,1815 ) //"ICMS     :"
		EndIf
		oReport:SkipLine()

		nLinPC := oReport:Row()
		oReport:PrintText( STR0073 + Transform(xMoeda(nTotFrete,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nTotFrete,14,MsDecimais(MV_PAR12))) ,nLinPC,1320 ) //"Frete    :"
		oReport:PrintText( STR0074 + Transform(xMoeda(nTotDesp ,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nTotDesp ,14,MsDecimais(MV_PAR12))) ,nLinPC,1815 ) //"Despesas :"
		oReport:SkipLine()
		oReport:PrintText("Frete: " + IF( SC7->C7_TPFRETE $ "F","FOB",IF(SC7->C7_TPFRETE $ "C","CIF"," " )) ,nLinPC,1320 )
		oReport:SkipLine()

		//Ŀ
		// Inicializar campos de Observacoes.                           
		//
		If Empty(cObs02)
			If Len(cObs01) > 50
				cObs := cObs01
				cObs01 := Substr(cObs,1,50)
				For nX := 2 To 4
					cVar  := "cObs"+StrZero(nX,2)
					&cVar := Substr(cObs,(50*(nX-1))+1,50)
				Next nX
			EndIf
		Else
			cObs01:= Substr(cObs01,1,IIf(Len(cObs01)<50,Len(cObs01),50))
			cObs02:= Substr(cObs02,1,IIf(Len(cObs02)<50,Len(cObs01),50))
			cObs03:= Substr(cObs03,1,IIf(Len(cObs03)<50,Len(cObs01),50))
			cObs04:= Substr(cObs04,1,IIf(Len(cObs04)<50,Len(cObs01),50))
		EndIf

		cComprador:= ""
		cAlter	  := ""
		cAprov1	  := ""
		cAprov2	  := ""
		cAprov3	  := ""
		cAprovFim := ""
		lNewAlc	  := .F.
		lLiber 	  := .F.

		dbSelectArea("SC7")
		//If !Empty(SC7->C7_APROV)
			cTipoSC7:= IIF((SC7->C7_TIPO == 1 .OR. SC7->C7_TIPO == 3),"PC","AE")
			lNewAlc := .T.
			PSWOrder( 1  )
			If PSWSeek( SC7->C7_COMPRAD , .T.)
				cComprador := Alltrim(PswRet()[1,4])
			Endif

			//if mv_par10==1
			_cAprov1   := ""
			_cAprov2   := ""
			_cAprov3   := ""
			_cAprovFim:= ""

			dbSelectArea("SAL")
			SAL->(dbSetOrder(5))
			FOR nW:= 1 to len(aAprov1)
				if aAprov1[nW]!= _cAprov1	.AND. AT(aAprov1[nW],cAprov1) == 0
					SAL->(dbGoTop())
					SAL->(dbSeek(xFilial("SAL")+aAprov1[nW]))
					//cAprov1 += "["+Alltrim(aAprov1[nW])+"] "+Alltrim(SAL->AL_NOME)+" ["+Alltrim(SAL->AL_DESC)+"]  "
					cAprov1 += Alltrim(SAL->AL_NOME)+" ["+Alltrim(SAL->AL_DESC)+"]  "
				Endif
				_cAprov1:= aAprov1[nW]
			Next nW
			FOR nW:= 1 to len(aAprov2)
				if aAprov2[nW]!= _cAprov2	.AND. AT(aAprov2[nW],cAprov2) == 0
					SAL->(dbGoTop())
					SAL->(dbSeek(xFilial("SAL")+aAprov2[nW]))
					//cAprov2 += "["+Alltrim(aAprov2[nW])+"] "+Alltrim(SAL->AL_NOME)+" ["+Alltrim(SAL->AL_DESC)+"]  "
					cAprov2 += Alltrim(SAL->AL_NOME)+" ["+Alltrim(SAL->AL_DESC)+"]  "
				Endif
				_cAprov2:= aAprov2[nW]
			Next nW
			FOR nW:= 1 to len(aAprov3)
				if aAprov3[nW]!= _cAprov3	.AND. AT(aAprov3[nW],cAprov3) == 0
					SAL->(dbGoTop())
					SAL->(dbSeek(xFilial("SAL")+aAprov3[nW]))
					//cAprov3 += "["+Alltrim(aAprov3[nW])+"] "+Alltrim(SAL->AL_NOME)+" ["+Alltrim(SAL->AL_DESC)+"]  "
					cAprov3 += Alltrim(SAL->AL_NOME)+" ["+Alltrim(SAL->AL_DESC)+"]  "
				Endif
				_cAprov3:= aAprov3[nW]
			Next nW

			cAprov1 := StrTran(cAprov1,"[]","")
			cAprov2 := StrTran(cAprov2,"[]","")
			cAprov3 := StrTran(cAprov3,"[]","")

			/*
			FOR nW:= 1 to len(aAprovFim)
				if aAprovFim[nW]!= _cAprovFim	.AND. AT(aAprovFim[nW],cAprovFim) == 0
					SAL->(dbGoTop())
					SAL->(dbSeek(xFilial("SAL")+aAprovFim[nW]))
					//cAprovFim += aAprovFim[nW]+"-"+Alltrim(SAL->AL_NOME)+"-"+Alltrim(SAL->AL_DESC)+" / "
					cAprovFim += Alltrim(SAL->AL_NOME)+"-"+Alltrim(SAL->AL_DESC)+" / "
				Endif
				_cAprovFim:= aAprovFim[nW]
			Next nW
			cAprovFim := StrTran(cAprovFim,"-","")
			*/
 			If SC7->C7_CONAPRO != "B"
				lLiber := .T.
			EndIf

			/*
			Else


			dbSelectArea("SCR")
			dbSetOrder(1)
			dbSeek(xFilial("SCR")+cTipoSC7+SC7->C7_NUM)
			While !Eof() .And. SCR->CR_FILIAL+Alltrim(SCR->CR_NUM) == xFilial("SCR")+Alltrim(SC7->C7_NUM) .And. SCR->CR_TIPO == cTipoSC7
				cAprov += upper(AllTrim(UsrRetName(SCR->CR_USER)))+" ["
				Do Case
					Case SCR->CR_STATUS=="03" //Liberado
						cAprov += "Ok"
					Case SCR->CR_STATUS=="04" //Bloqueado
						cAprov += "BLQ"
					Case SCR->CR_STATUS=="05" //Nivel Liberado
						cAprov += "NL"
					OtherWise                 //Aguar.Lib
						cAprov += "AL"
				EndCase
				cAprov += "] - "
				dbSelectArea("SCR")
				dbSkip()
			Enddo
			Endif
			*/
			If !Empty(SC7->C7_GRUPCOM)
				dbSelectArea("SAJ")
				dbSetOrder(1)
				dbSeek(xFilial("SAJ")+SC7->C7_GRUPCOM)
				While !Eof() .And. SAJ->AJ_FILIAL+SAJ->AJ_GRCOM == xFilial("SAJ")+SC7->C7_GRUPCOM
					If SAJ->AJ_USER != SC7->C7_USER
						cAlter += AllTrim(SAJ->AJ_USER)+"-"+Alltrim(AJ_US2NAME)+"/"
					EndIf
					dbSelectArea("SAJ")
					dbSkip()
				EndDo
			EndIf
		//EndIf

		oReport:SkipLine()
		nLinPC := oReport:Row()
		oReport:PrintText( STR0077 ,nLinPC, 050 ) // "Observacoes "
		oReport:PrintText( STR0076 + Transform(xMoeda(nTotSeguro,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nTotSeguro,14,MsDecimais(MV_PAR12))) ,nLinPC-30, 1815 ) // "SEGURO   :"

		oReport:SkipLine()

		nLinAux := oReport:Row()+50

		nTamLin := 70
		nTab := 3
		lWrap := .T.



		nLines := MLCOUNT(cMensagem, nTamLin, nTab, lWrap)

		IIF(nLines > 8, nLines:=8, nLines:=nLines)

		For nCurrentLine := 1 TO nLines
		     oReport:Say(nLinAux,0050,MEMOLINE(cMensagem, nTamLin, nCurrentLine, nTab, lWrap))
		     nLinAux+=35
		Next

		oReport:SkipLine()
		oReport:SkipLine()
		//oReport:SkipLine()

		nLinPC := oReport:Row()
//		oReport:PrintText(cObs02,,050 )
//		oReport:PrintText(cObs03,,050 )

		If !lNewAlc
			oReport:PrintText( STR0078 + Transform(xMoeda(nTotalNF,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nTotalNF,14,MsDecimais(MV_PAR12))) ,nLinPC,1774 ) //"Total Geral :"
		Else
			If lLiber
				oReport:PrintText( STR0078 + Transform(xMoeda(nTotalNF,SC7->C7_MOEDA,MV_PAR12,SC7->C7_DATPRF,MsDecimais(SC7->C7_MOEDA),nTxMoeda) , tm(nTotalNF,14,MsDecimais(MV_PAR12))) ,nLinPC,1774 )
			Else
				oReport:PrintText( STR0078 + If((SC7->C7_TIPO == 1 .OR. SC7->C7_TIPO == 3),STR0051,STR0086) ,nLinPC,1390 )
			EndIf
		EndIf
		oReport:SkipLine()

		oReport:PrintText(cObs04,,050 )



		//oReport:Box( 2570 , 1220 , 2800 , 1650 )
		//oReport:Box( 2570 , 1650 , 2800 , nPageWidth )
		oReport:Box( 2570 , 1220 , 2800 , nPageWidth )

		nLinPC := oReport:Row()
		oReport:SkipLine()
		//oReport:PrintText("Frete: " + IF( SC7->C7_TPFRETE $ "F","FOB",IF(SC7->C7_TPFRETE $ "C","CIF"," " )) ,,1670 )
		oReport:SkipLine()
		oReport:SkipLine()
		oReport:SkipLine()

		//oReport:PrintText("Transportadora",nLinPC,1670)
		//oReport:PrintText( If((SC7->C7_TIPO == 1 .OR. SC7->C7_TIPO == 3),STR0084),nLinPC,1310) //"Liberacao do Pedido"##"Liber. Autorizacao "


		//oReport:PrintText( If(nQtdL==nQtd,"P E D I D O   L I B E R A D O","PEDIDO PARCIALMENTE LIBERADO"),,1510)
		oReport:PrintText( If(nQtdL==nQtd,"P E D I D O   L I B E R A D O","P E D I D O   B L O Q U E A D O"),,1510)

		oReport:SkipLine()
		oReport:SkipLine()
		oReport:SkipLine()
		oReport:SkipLine()

		/*
		dbSelectArea("SA4")
		dbSetOrder(1)
		dbGoTop()
		If dbSeek(xFilial("SA4")+SC7->C7_TRANSP)
			oReport:PrintText(ALLTRIM(SA4->A4_NOME),,1670 )
			oReport:PrintText("Fone: " + TRANSFORM(ALLTRIM(SA4->A4_DDD)+ALLTRIM(SA4->A4_TEL),"@R (99) 9999-9999"),,1670 )
			oReport:PrintText("E-mail: " + ALLTRIM(SA4->A4_EMAIL),,1670 )
			oReport:SkipLine()
			oReport:PrintText("Frete: " + IF( SC7->C7_TPFRETE $ "F","FOB",IF(SC7->C7_TPFRETE $ "C","CIF"," " )) ,,1670 )
		Else
			oReport:SkipLine()
			oReport:PrintText("Frete: " + IF( SC7->C7_TPFRETE $ "F","FOB",IF(SC7->C7_TPFRETE $ "C","CIF"," " )) ,,1670 )
			oReport:SkipLine()
			oReport:SkipLine()
			oReport:SkipLine()
		EndIf
		*/

		nLinPC := oReport:Row()

		oReport:PrintText(STR0052+" "+Substr(cComprador,1,60),nLinPC,050 ) 	//"Comprador Responsavel :" //"BLQ:Bloqueado"
		oReport:SkipLine()
		oReport:SkipLine()

		if !Empty(Alltrim(cAprov1))
		oReport:PrintText(STR0121+" "+Substr(cAprov1,001,430) ,,050 ) //"Aprovador Nivel 1 :"
		oReport:PrintText(            Substr(cAprov1,431,130) ,,440 ) //"Aprovador Nivel 1 :"
		oReport:SkipLine()
		Endif

		if !Empty(Alltrim(cAprov2))
		oReport:PrintText(STR0122+" "+Substr(cAprov2,001,430) ,,050 ) //"Aprovador Nivel 2 :"
		oReport:PrintText(            Substr(cAprov2,431,130) ,,440 ) //"Aprovador Nivel 2 :"
		oReport:SkipLine()
		Endif

		if !Empty(Alltrim(cAprov3))
		oReport:PrintText(STR0123+" "+Substr(cAprov3,001,430) ,,050 ) //"Aprovador Nivel 3 :"
		oReport:PrintText(            Substr(cAprov3,431,130) ,,440 ) //"Aprovador Nivel 3 :"
		oReport:SkipLine()
		Endif
		//oReport:PrintText(STR0054+" "+If( Len(cAprov) > 0 , Substr(cAprov,001,130) , Substr(cAprovFim,001,140) ),,050 ) //"Compradores Alternativos :"
		//oReport:PrintText(            If( Len(cAprov) > 0 , Substr(cAprov,131,130) , Substr(cAprovFim,141,140) ),,440 ) //"Compradores Alternativos :"
		//oReport:SkipLine()
		//oReport:PrintText("Aprovador Final: "+If( Len(cAprovFim) > 0 , Substr(cAprovFim,001,140) , " " ),,050 ) //"Aprovador(es) :"
		//oReport:PrintText(            		  If( Len(cAprovFim) > 0 , Substr(cAprovFim,141,140) , " " ),,310 ) //"Aprovador(es) :"
		//oReport:SkipLine()

		nLinPC := oReport:Row()
		/*
		oReport:PrintText( STR0082+" "+STR0060 ,nLinPC, 050 ) 	//"Legendas da Aprovacao : //"BLQ:Bloqueado"
		oReport:PrintText(       "|  "+STR0061 ,nLinPC, 610 ) 	//"Ok:Liberado"
		oReport:PrintText(       "|  AL:Aguar.Lib" ,nLinPC, 830 ) 	//"??:Aguar.Lib"
		oReport:PrintText(       "|  NL:Nivel Lib" ,nLinPC,1070 )	//"##:Nivel Lib"
		//oReport:PrintText(       "|  "+STR0062 ,nLinPC, 830 ) 	//"??:Aguar.Lib"
		//oReport:PrintText(       "|  "+STR0067 ,nLinPC,1070 )	//"##:Nivel Lib"
		oReport:SkipLine()

		oReport:Box(nLinPc-10, 0010 , oReport:Row()+10 , nPageWidth )
		oReport:Line( oReport:Row()+10 , 0010 , oReport:Row()+10 , nPageWidth )
		*/
		oReport:SkipLine()
		If SC7->C7_TIPO == 1 .OR. SC7->C7_TIPO == 3
			oReport:PrintText("NOTA: So aceitaremos a mercadoria se na sua Nota Fiscal constar o numero do nosso Pedido de Compras."/*STR0081*/,,050 ) //"NOTA: So aceitaremos a mercadoria se na sua Nota Fiscal constar o numero do nosso Pedido de Compras."
		Else
			oReport:PrintText("NOTA: So aceitaremos a mercadoria se na sua Nota Fiscal constar o numero da Autorizacao de Entrega."/*STR0083*/,,050 ) //"NOTA: So aceitaremos a mercadoria se na sua Nota Fiscal constar o numero da Autorizacao de Entrega."
		EndIf


	Next nVias

	MaFisEnd()

	//Ŀ
	// Grava no SC7 as Reemissoes e atualiza o Flag de impressao.   
	//
	dbSelectArea("SC7")
	If Len(aRecnoSave) > 0
		For nX :=1 to Len(aRecnoSave)
			dbGoto(aRecnoSave[nX])
			RecLock("SC7",.F.)
			SC7->C7_QTDREEM := (SC7->C7_QTDREEM + 1)
			SC7->C7_EMITIDO := "S"
			MsUnLock()
		Next nX
		//Ŀ
		// Reposiciona o SC7 com base no ultimo elemento do aRecnoSave. 
		//
		dbGoto(aRecnoSave[Len(aRecnoSave)])
	Endif

	Aadd(aPedMail,aPedido)

	aRecnoSave := {}

	dbSelectArea("SC7")
	dbSkip()

EndDo

oSection2:Finish()

//Ŀ
// Executa o ponto de entrada M110MAIL quando a impressao for   
// enviada por email, fornecendo um Array para o usuario conten 
// do os pedidos enviados para possivel manipulacao.            
//
If ExistBlock("M110MAIL")
	lEnvMail := HasEmail(,,,,.F.)
	If lEnvMail
		Execblock("M110MAIL",.F.,.F.,{aPedMail})
	EndIf
EndIf

If lAuto .And. !lImpri
	//Aviso(STR0104,STR0105,{"OK"})
Endif

dbSelectArea("SC7")
dbClearFilter()
dbSetOrder(1)

Return

/*/


Ŀ
Programa  CabecPCxAE Autor Alexandre Inacio Lemes Data  06/09/2006
Ĵ
Descrio  Emissao do Pedido de Compras / Autorizacao de Entrega      
Ĵ
Sintaxe    CabecPCxAE(ExpO1,ExpO2,ExpN1,ExpN2)                        
Ĵ
Parametros ExpO1 = Objeto oReport                      	              
           ExpO2 = Objeto da sessao1 com o cabec                      
           ExpN1 = Numero de Vias                                     
           ExpN2 = Numero de Pagina                                   
Ĵ
Retorno   Nenhum                                                      
ٱ


/*/
Static Function CabecPCxAE(oReport,oSection1,nVias,nPagina)

Local cMoeda := IIf( mv_par12 < 10 , Str(mv_par12,1) , Str(mv_par12,2) )
Local nLinPC := 0
Local nPageWidth:= 2290
TRPosition():New(oSection1,"SA2",1,{ || xFilial("SA2") + SC7->C7_FORNECE + SC7->C7_LOJA })

SA2->(dbSetOrder(1))
SA2->(dbSeek(xFilial("SA2") + SC7->C7_FORNECE + SC7->C7_LOJA))

oSection1:Init()

oReport:Box( 010 , 010 ,  260 , 1000 )
oReport:Box( 010 , 1010,  260 , nPageWidth-2 ) // 2288

oReport:PrintText( If(nPagina > 1,(STR0033)," "),,oSection1:Cell("M0_NOMECOM"):ColPos())

nLinPC := oReport:Row()
oReport:PrintText( If( mv_par08 == 1 , (STR0068), (STR0069) ) + " - " + GetMV("MV_MOEDA"+cMoeda) ,nLinPC,1030 )
oReport:PrintText( If( mv_par08 == 1 , SC7->C7_NUM, SC7->C7_NUMSC + "/" + SC7->C7_NUM ) + " /" + Ltrim(Str(nPagina,2)) ,nLinPC,1910 )
oReport:SkipLine()

nLinPC := oReport:Row()
oReport:PrintText( If( SC7->C7_QTDREEM > 0, Str(SC7->C7_QTDREEM+1,2) , "1" ) + STR0034 + Str(nVias,2) + STR0035 ,nLinPC,1910 )

oReport:SkipLine()
nLinPC := oReport:Row()
oReport:PrintText(STR0087 + SM0->M0_NOMECOM,nLinPC,15)  // "Empresa:"
oReport:PrintText(STR0106 + Alltrim(SA2->A2_NOME)+" "+STR0107+SA2->A2_COD+" "+STR0108+SA2->A2_LOJA,nLinPC,1025)
oReport:SkipLine()

nLinPC := oReport:Row()
oReport:PrintText(STR0088 + SM0->M0_ENDENT,nLinPC,15)
oReport:PrintText(STR0088 + SA2->A2_END+" "+STR0109+SA2->A2_BAIRRO,nLinPC,1025)
oReport:SkipLine()

nLinPC := oReport:Row()
oReport:PrintText(STR0089 + Trans(SM0->M0_CEPENT,PesqPict("SA2","A2_CEP"))+Space(5)+STR0090 + Alltrim(SM0->M0_CIDENT) + STR0091 + SM0->M0_ESTENT ,nLinPC,15)
oReport:PrintText(STR0110+SA2->A2_MUN+" "+STR0111+SA2->A2_EST+" "+STR0112+SA2->A2_CEP+" "+STR0113+Transform(SA2->A2_CGC,PesqPict("SA2","A2_CGC")),nLinPC,1025)
oReport:SkipLine()

nLinPC := oReport:Row()
oReport:PrintText(STR0092 + SM0->M0_TEL + Space(2) + STR0093 + SM0->M0_FAX ,nLinPC,15)
oReport:PrintText(STR0094 + "("+Substr(SA2->A2_DDD,1,3)+") "+Substr(SA2->A2_TEL,1,15) + " "+STR0114+"("+Substr(SA2->A2_DDD,1,3)+") "+SubStr(SA2->A2_FAX,1,15)+" "+If( cPaisLoc$"ARG|POR|EUA",space(11) , STR0095 )+If( cPaisLoc$"ARG|POR|EUA",space(18), SA2->A2_INSCR ),nLinPC,1025)
oReport:SkipLine()

nLinPC := oReport:Row()
oReport:PrintText(STR0096 + Transform(SM0->M0_CGC,PesqPict("SA2","A2_CGC")) ,nLinPC,15)
If cPaisLoc == "BRA"
	oReport:PrintText(STR0041 + InscrEst() ,nLinPC,415)
Endif

/*
dbSelectArea("SU5")
dbSetOrder(1)
dbGoTop()
If dbSeek(xFilial("SU5")+SC7->C7_CODCON)
	nLinPC := oReport:Row()
	oReport:PrintText("Contato: " + ALLTRIM(SU5->U5_CONTAT) + " - " + TRANSFORM(ALLTRIM(SU5->U5_DDD)+ALLTRIM(SU5->U5_FCOM1),"@R (99) 9999-9999") + " - " + SU5->U5_EMAIL,nLinPC,1025)
EndIf
*/
oReport:SkipLine()
oReport:SkipLine()

oSection1:Finish()

Return

Static Function R110FIniPC(cPedido,cItem,cSequen,cFiltro)

Local aArea		:= GetArea()
Local aAreaSC7	:= SC7->(GetArea())
Local cValid		:= ""
Local nPosRef		:= 0
Local nItem		:= 0
Local cItemDe		:= IIf(cItem==Nil,'',cItem)
Local cItemAte	:= IIf(cItem==Nil,Repl('Z',Len(SC7->C7_ITEM)),cItem)
Local cRefCols	:= ''
DEFAULT cSequen	:= ""
DEFAULT cFiltro	:= ""

dbSelectArea("SC7")
dbSetOrder(1)
If dbSeek(xFilial("SC7")+cPedido+cItemDe+Alltrim(cSequen))
	MaFisEnd()
	MaFisIni(SC7->C7_FORNECE,SC7->C7_LOJA,"F","N","R",{})
	While !Eof() .AND. SC7->C7_FILIAL+SC7->C7_NUM == xFilial("SC7")+cPedido .AND. ;
			SC7->C7_ITEM <= cItemAte .AND. (Empty(cSequen) .OR. cSequen == SC7->C7_SEQUEN)

		// Nao processar os Impostos se o item possuir residuo eliminado
		If &cFiltro
			dbSelectArea('SC7')
			dbSkip()
			Loop
		EndIf

		// Inicia a Carga do item nas funcoes MATXFIS
		nItem++
		MaFisIniLoad(nItem)
		dbSelectArea("SX3")
		dbSetOrder(1)
		dbSeek('SC7')
		While !EOF() .AND. (X3_ARQUIVO == 'SC7')
			cValid	:= StrTran(UPPER(SX3->X3_VALID)," ","")
			cValid	:= StrTran(cValid,"'",'"')
			If "MAFISREF" $ cValid
				nPosRef  := AT('MAFISREF("',cValid) + 10
				cRefCols := Substr(cValid,nPosRef,AT('","MT120",',cValid)-nPosRef )
				// Carrega os valores direto do SC7.
				MaFisLoad(cRefCols,&("SC7->"+ SX3->X3_CAMPO),nItem)
			EndIf
			dbSkip()
		End
		MaFisEndLoad(nItem,2)
		dbSelectArea('SC7')
		dbSkip()
	End
EndIf

RestArea(aAreaSC7)
RestArea(aArea)

Return .T.

static function ajustaSx1(cPerg)
	putSx1(cPerg, "01", "Pedido de?"	  , "", "", "mv_ch1", "C", tamSx3("C7_NUM")[1]		, 0, 0, "G", "", "", "SC7", "", "mv_par01")
	putSx1(cPerg, "02", "Pedido Ate?"	  , "", "", "mv_ch2", "C", tamSx3("C7_NUM")[1]		, 0, 0, "G", "", "", "SC7", "", "mv_par02")
	putSx1(cPerg, "03", "Emissao de?"	  , "", "", "mv_ch3", "D", tamSx3("C7_EMISSAO")[1] 	, 0, 0, "G", "", ""	,   "", "", "mv_par03")
	putSx1(cPerg, "04", "Emissao Ate?"	  , "", "", "mv_ch4", "D", tamSx3("C7_EMISSAO")[1]	, 0, 0, "G", "", ""	,   "", "", "mv_par04")
	PutSX1(cPerg, "05", "Somente novos?"  , "", "", "mv_ch5", "N",                         1, 0, 0, "C" ,"" ,"" ,   "", "", "mv_par05","Sim", "", "", "","Nao")
	putSx1(cPerg, "06", "Descr.Produto"	  , "", "", "mv_ch6", "C",                        10, 0, 0, "G", "", ""	,   "", "", "mv_par06","", "", "", "", "", "", "","", "", "",	"", "", "",	"", "", "",	{"B1_DESC cadastro de produtos","B5_CEME descrio cientifica do produto","C7_DESCRI descrio no pedido de compras"}, {"","",""}, {"","",""})
	putSx1(cPerg, "07", "Qual Unid.Med?"  , "", "", "mv_ch7", "N", 				   	       1, 0, 1, "C", "", "" ,   "", "", "mv_par07","Primaria", "", "", "", "Secundaria", "", "","Todos", "", "",	"", "", "",	"", "", "",	{"Selecione qual unidade de medida deve","ser impressa no pedido de compras.",""}, {"","",""}, {"","",""})
	putSx1(cPerg, "08", "Imprime ?"       , "", "", "mv_ch8", "N", 				   	       1, 0, 1, "C", "", "" ,   "", "", "mv_par08","Pedido Compra", "", "", "", "Aut. de Entrega", "", "","", "", "",	"", "", "",	"", "", "",	{"Seleciona a impresso de pedido de","compras ou autorizao de entrega.",""}, {"","",""}, {"","",""})
	putSx1(cPerg, "09", "Numero de Vias ?", "", "", "mv_ch9", "N", 				   	       2, 0, 1, "G", "", "" ,   "", "", "mv_par09","", "", "", "", "", "", "","", "", "",	"", "", "",	"", "", "",	{"Seleciona a quantidade de vias a ser","impressa de cada pedido.",""}, {"","",""}, {"","",""})
	putSx1(cPerg, "10", "Imprime Pedidos?", "", "", "mv_chA", "N", 				   	       1, 0, 1, "C", "", "" ,   "", "", "mv_par10","Liberados", "", "", "", "Bloqueados", "", "","Ambos", "", "",	"", "", "",	"", "", "",	{"","",""}, {"","",""}, {"","",""})
	putSx1(cPerg, "11", "Considera SCs ?" , "", "", "mv_chB", "N", 				   	       1, 0, 1, "C", "", "" ,   "", "", "mv_par11","Firmes", "", "", "", "Previstas", "", "","Ambos", "", "",	"", "", "",	"", "", "",	{"","",""}, {"","",""}, {"","",""})
	putSx1(cPerg, "12", "Qual moeda ?"    , "", "", "mv_chC", "N", 				   	       1, 0, 1, "C", "", "" ,   "", "", "mv_par12","Moeda 1", "", "", "", "Moeda 2", "", "","Moeda 3", "", "",	"Moeda 4", "", "",	"Moeda 5", "", "",	{"Dependendo da moeda o pedido","ser convertido pela moeda","selecionada"}, {"","",""}, {"","",""})
	putSx1(cPerg, "13", "Endereco Entrega", "", "", "mv_chD", "C",                        40, 0, 0, "G", "", ""	,   "", "", "mv_par13")
	putSx1(cPerg, "14", "Lista quais ?"   , "", "", "mv_chE", "N", 				   	       1, 0, 1, "C", "", "" ,   "", "", "mv_par14","Todos", "", "", "", "Em aberto", "", "","Atendidos", "", "",	"", "", "",	"", "", "",	{"","",""}, {"","",""}, {"","",""})
return

